#ifndef _FRAMEWORK_HPP_
#define _FRAMEWORK_HPP_

#include <iostream>
#include "Singleton.hpp"
#include "Timer.hpp"

using namespace std;

#define g_pFramework CFramework::Get()
#define SAFE_DELETE(x) { if(x != NULL) { delete(x); x = NULL; } }

class CFramework : public TSingleton<CFramework>
{
public:
	bool Init(int ScreenWidth, int ScreenHeight, int ColorDepth, bool bFullscreen);
	void Quit();
	void Update();
	void Clear();
	void Flip();
	bool KeyDown(int keyID);
	SDL_Surface *GetScreen() { return m_pScreen; }

private:
	SDL_Surface *m_pScreen;
	Uint8 *m_pKeystate;
};

#endif